diff -ur mythtv-0.22.orig/programs/mythfrontend/playbackbox.cpp mythtv-0.22/programs/mythfrontend/playbackbox.cpp
--- mythtv-0.22.orig/programs/mythfrontend/playbackbox.cpp	2009-10-23 18:58:54.000000000 -0700
+++ mythtv-0.22/programs/mythfrontend/playbackbox.cpp	2009-12-12 23:31:21.000000000 -0800
@@ -1820,8 +1820,7 @@
 {
     if (m_popupMenu)
         return;
-
-    QString label = tr("Recording List Menu");
+    QString label = tr("Group List Menu");
 
     ProgramInfo *pginfo = CurrentItem();
 
@@ -1869,6 +1868,12 @@
     }
 
     m_popupMenu->AddButton(tr("Help (Status Icons)"), SLOT(showIconHelp()));
+
+    if (GetFocusWidget() != m_groupList)
+    {
+        m_popupMenu->AddButton(tr("Recording Options Menu"),
+			       SLOT(showActionsSelected()));
+    }
 }
 
 void PlaybackBox::showActionsSelected()
@@ -2410,6 +2415,10 @@
                      SLOT(doPlaylistExpireSetOff()));
     m_popupMenu->AddButton(tr("Enable Auto Expire"),
                      SLOT(doPlaylistExpireSetOn()));
+    m_popupMenu->AddButton(tr("Mark As Watched"),
+                     SLOT(doPlaylistWatchedSetOn()));
+    m_popupMenu->AddButton(tr("Mark As UN-Watched"),
+                     SLOT(doPlaylistWatchedSetOff()));
 }
 
 void PlaybackBox::showPlaylistJobPopup()
@@ -2801,13 +2810,19 @@
                                         SLOT(showPlayFromPopup()), true);
         else
             m_popupMenu->AddButton(tr("Play"), SLOT(playSelected()));
-
+                     
         if (m_playList.filter(pginfo->MakeUniqueKey()).size())
             m_popupMenu->AddButton(tr("Remove from Playlist"),
                                         SLOT(togglePlayListItem()));
         else
             m_popupMenu->AddButton(tr("Add to Playlist"),
                                         SLOT(togglePlayListItem()));
+        if (m_playList.size())
+        {
+            m_popupMenu->AddButton(tr("Playlist options"),
+                         SLOT(showPlaylistPopup()), true);
+        } 
+                                               
     }
 
     if (pginfo->recstatus == rsRecording &&
@@ -2842,6 +2857,8 @@
             m_popupMenu->AddButton(tr("Delete"), SLOT(askDelete()));
         }
     }
+    m_popupMenu->AddButton(tr("Group List Menu"),
+                                SLOT(showMenu()));
 }
 
 void PlaybackBox::showFileNotFoundActionPopup(ProgramInfo *pginfo)
@@ -3516,7 +3533,13 @@
         if (action == "1" || action == "HELP")
             showIconHelp();
         else if (action == "MENU")
-            showMenu();
+        
+        { 
+            if (GetFocusWidget() == m_groupList)
+                showMenu();
+            else showActionsSelected();
+        }
+            
         else if (action == "NEXTFAV")
         {
             if (GetFocusWidget() == m_groupList)
@@ -3577,8 +3600,6 @@
             else if (action == "PLAYBACK")
                 playSelected(m_recordingList->GetItemCurrent());
             else if (action == "INFO")
-                showActionsSelected();
-            else if (action == "DETAILS")
                 details();
             else if (action == "CUSTOMEDIT")
                 customEdit();
@@ -4340,6 +4361,19 @@
     }
 }
 
+void PlaybackBox::doPlaylistWatchedSetting(bool turnOn)
+{
+    ProgramInfo *tmpItem;
+    QStringList::Iterator it;
+
+    for (it = m_playList.begin(); it != m_playList.end(); ++it)
+    {
+        if ((tmpItem = findMatchingProg(*it)))
+        {
+            tmpItem->SetWatchedFlag(turnOn);
+        }
+    }
+}
 void PlaybackBox::showMetadataEditor()
 {
     ProgramInfo *pgInfo = CurrentItem();
diff -ur mythtv-0.22.orig/programs/mythfrontend/playbackbox.h mythtv-0.22/programs/mythfrontend/playbackbox.h
--- mythtv-0.22.orig/programs/mythfrontend/playbackbox.h	2009-10-23 18:58:54.000000000 -0700
+++ mythtv-0.22/programs/mythfrontend/playbackbox.h	2009-12-11 16:28:14.000000000 -0800
@@ -249,6 +249,9 @@
     void doPlaylistExpireSetting(bool turnOn);
     void doPlaylistExpireSetOn()      { doPlaylistExpireSetting(true);  }
     void doPlaylistExpireSetOff()     { doPlaylistExpireSetting(false); }
+    void doPlaylistWatchedSetting(bool turnOn);
+    void doPlaylistWatchedSetOn()      { doPlaylistWatchedSetting(true);  }
+    void doPlaylistWatchedSetOff()     { doPlaylistWatchedSetting(false); }
     void togglePlayListTitle(void);
     void togglePlayListItem(void);
     void playSelectedPlaylist(bool random);
Only in mythtv-0.22/programs/mythfrontend: playbackbox.h.orig
